using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Linq;
using TMPro;
using UnityEngine.UI;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            CategoryBuilder.Create("Test", "None", ModAPI.LoadSprite("category icon.png"));

            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Assistant History",
                               DescriptionOverride = "Assistant Librarian of the History Floor",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("111.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("Assistant History.png"),
                                   };
                               }
                           }
                       );
                         
            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Assistant of technological sciences ",
                               DescriptionOverride = "Assistant Librarian of the technological sciences Floor",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("222.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("Assistant of Technological Sciences.png"),
                                   };
                               }
                           }
                       );           
           
            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Assistant of literature ",
                               DescriptionOverride = "Assistant Librarian of the literature Floor",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("333.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("Hod.png"),
                                   };
                               }
                           }
                       );   
               
            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Assistant of art",
                               DescriptionOverride = "Assistant Librarian of the art Floor",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("444.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("Netzah.png"),
                                   };
                               }
                           }
                       );           
           

            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Assistant of natural sciences ",
                               DescriptionOverride = "Assistant Librarian of natural sciences  Floor",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("555.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("Tifferet.png"),
                                   };
                               }
                           }
                       );           
          
           

            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Assistant of linguistics  ",
                               DescriptionOverride = "Assistant Librarian of the linguistics Floor",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("666.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("Gebura.png"),
                                   };
                               }
                           }
                       );           

            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Assistant of social sciences ",
                               DescriptionOverride = "Assistant Librarian of the social sciences Floor",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("777.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("Blue.png"),
                                   };
                               }
                           }
                       );           

            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Assistant of philosophy ",
                               DescriptionOverride = "Assistant Librarian of the philosophy Floor",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("888.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("Binah.png"),
                                   };
                               }
                           }
                       );           

            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Assistant of religion ",
                               DescriptionOverride = "Assistant Librarian of the religion Floor",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("999.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("9999.png"),
                                   };
                               }
                           }
                       );           
         
            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Assistant of general purpose ",
                               DescriptionOverride = "Assistant Librarian of the general purpose Floor",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("1110.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("1111.png"),
                                   };
                               }
                           }
                       );           

            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Hokma",
                               DescriptionOverride = "Librarian patron of the floor of religion",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("IcoHokma.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("Hokma.png"),
                                   };
                               }
                           }
                       );           

           
            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Roland",
                               DescriptionOverride = "The librarian is the patron of the Keter floor",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("icoRoland.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("Roland.png"),
                                   };
                               }
                           }
                       );           

            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "Black silence",
                               DescriptionOverride = "One of the five famous color spotters",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("icoBlack silence.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("Black silence.png"),
                                   };
                               }
                           }
                       );           

            ModAPI.Register(
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Human"),
                               NameOverride = "...",
                               DescriptionOverride = "...",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("100.png"),
                               AfterSpawn = (Instance) =>
                               {
                                   var person = Instance.GetComponent<PersonBehaviour>();

                                   var Head = Instance.transform.Find("Head").gameObject;

                                   Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 1;
                                   Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                                   {
                            ModAPI.LoadTexture("001.png"),
                                   };
                               }
                           }
                       );           




















      





        






    










































































            ModAPI.Register( 
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Sword"),
                               NameOverride = "Sword ",
                               DescriptionOverride = "librarians starting weapon",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("icon sword.png"),
                               AfterSpawn = (Instance) =>
                               {
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sword.png", 1f);
                                    Instance.FixColliders();  

                                }

                            }                         

                        );  

            ModAPI.Register( 
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Sword"),
                               NameOverride = "Rapier",
                               DescriptionOverride = "Chokmah's starting weapon",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("icon rapier.png"),
                               AfterSpawn = (Instance) =>
                               {
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("rapier.png", 1f);
                                    Instance.FixColliders();  

                                }

                            }                         

                        );  


            ModAPI.Register( 
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Knife"),
                               NameOverride = "Black knife",
                               DescriptionOverride = "created by logic studio",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("Black knife.png"),
                               AfterSpawn = (Instance) =>
                               {
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("icoBlack knife.png", 1f);
                                    Instance.FixColliders();  

                                }

                            }                         

                        );  

            ModAPI.Register( 
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Pistol"),
                               NameOverride = "Black pistol",
                               DescriptionOverride = "created by logic studio",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("Black pistol.png"),
                               AfterSpawn = (Instance) =>
                               {
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("icoBlack pistol.png", 1f);
                                    Instance.FixColliders();  

                                }

                            }                         

                        );  

            ModAPI.Register( 
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                               NameOverride = "Black shotgun",
                               DescriptionOverride = "created by logic studio",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("Black shotgun.png"),
                               AfterSpawn = (Instance) =>
                               {
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("icoBlack shotgun.png", 1f);
                                    Instance.FixColliders();  

                                }

                            }                         

                        );  

            ModAPI.Register( 
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Lance"),
                               NameOverride = "Black lance",
                               DescriptionOverride = "created by logic studio",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("Black lance.png"),
                               AfterSpawn = (Instance) =>
                               {
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("icoblack lance.png", 1f);
                                    Instance.FixColliders();  

                                }

                            }                         

                        );  

            ModAPI.Register( 
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Sword"),
                               NameOverride = "Black sword",
                               DescriptionOverride = "created by logic studio",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("Black sword.png"),
                               AfterSpawn = (Instance) =>
                               {
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("icoBlack sword.png", 1f);
                                    Instance.FixColliders();  

                                }

                            }                         

                        );  

            ModAPI.Register( 
                           new Modification()
                           {
                               OriginalItem = ModAPI.FindSpawnable("Sword"),
                               NameOverride = "Black katana",
                               DescriptionOverride = "created by logic studio",
                               CategoryOverride = ModAPI.FindCategory("Test"),
                               ThumbnailOverride = ModAPI.LoadSprite("Black katana.png"),
                               AfterSpawn = (Instance) =>
                               {
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("icoBlack katana.png", 1f);
                                    Instance.FixColliders();  

                                }

                            }                         

                        );  











































































                ModAPI.Register(
                   new Modification()
               {
                 OriginalItem = ModAPI.FindSpawnable("Pistol"),
                   NameOverride = "PWS",
                   DescriptionOverride = "",
                   CategoryOverride = ModAPI.FindCategory("Hotline Miami"),
                   ThumbnailOverride = ModAPI.LoadSprite("I/IPWS.png"),
                   AfterSpawn = (Instance) =>
                   {
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("S/PWS.png", 1f);
                       Instance.FixColliders();

                   }
               }
            );
        }



















    public class MultipleSpriteHumanBehaviour : MonoBehaviour
        {
            public Texture2D[] Textures = new Texture2D[0];
            public PersonBehaviour person;
            public int CurrentTexture = -2;
            public int Scale = 3;

            void Start()
            {
                SetTexture();
            }

            public void SetTexture()
            {
                if (Textures.Length == 0)
                    return;

                if (CurrentTexture == -2)
                {
                    CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
                }
                person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
                for (int i = 0; i < person.Limbs.Length; i++)
                {
                    person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
                }
            }
        }
    }
}









